# Ej 11

import numpy as np
from matplotlib import pyplot
import matplotlib.pyplot as plt
from scipy.stats import norm 

#%%

def simulate_1d_bm(nsteps=1000, t=0.001):
    steps = [ np.random.randn()*np.sqrt(t) for i in range(nsteps) ]
    steps[0] = 0
    y = np.cumsum(steps)
    x = [ t*i for i in range(nsteps) ]
    return x, y

nsims = 10000
integral = np.zeros(nsims)
th_integral = np.zeros(nsims)
for i in range(nsims):
    x, y = simulate_1d_bm()

    aux = 0
    for j in range(1,1000):
        aux = aux + y[j-1]*(y[j]- y[j-1])
    integral[i] = aux
    th_integral[i] = (y[-1]**2 - 1)/2
    


#%%
    
print('Mean=', np.mean(integral))
print('Var=', np.var(integral))
print('Mean_th=', np.mean(th_integral))
print('Var_th=', np.var(th_integral))

fig = pyplot.figure()
fig.set_figheight(8)
fig.set_figwidth(12)
pyplot.hist(integral, bins= np.int(np.sqrt(nsims)+ 1), density = True, alpha=0.5, label='Integral'),
pyplot.hist(th_integral, bins= np.int(np.sqrt(nsims)+ 1), density = True, alpha=0.3, label='Th_Integral'),
pyplot.legend(loc='upper right')
pyplot.show()